#include "grn.h"

main (int argc, char** argv) {
  ExpressionData *ed;
  Tuple *tpl;
  HMM   *hmm;
  float w;

  clock_t start;
  start = clock();

  system("clear");

  cerr << "Detecting Candidate Regulation Relations in Microarray Time" << endl;
  cerr << "Series Data Using Multipe Hidden Markov Models" << endl;
  cerr << "" << endl;
  cerr << "Code writen by: Nawar Malhis, PhD" << endl;
  cerr << "Bioinformatics Center, University of British Columbia" << endl;
  cerr << "Vancouver, Canada" << endl;
  cerr << "nmalhis@bioinformatics.ubc.ca" << endl;
  cerr << "" << endl;
  cerr << "This code can be used for non-commercial purposes only" << endl;
  cerr << "" << endl;
  cerr << "" << endl;

  w = 0.13; 
  ed  = new ExpressionData(0.5, w); 
  tpl = new Tuple(ed);

  tpl->createRR();

  hmm = new HMM(ed, argc, argv[1], argv[2]);

  cerr << " Execution time:\t" << (clock() - start) / CLOCKS_PER_SEC << endl;

  free(tpl);
  free(ed);
} // main

