#if !defined(_grn)
#define _grn
#include <stdio.h>      /* for I/O usage           */
#include <string>
#include <time.h>
#include <iostream>
#include <fstream.h>
#include <algo.h>
#include <algorithm>
#include <ctype.h>      /* for tolower()           */
#include <vector>
#include <cstdlib>  // random number generation
#include <cctype>
#include <cmath>
using namespace std;

#define MAX_ITERATIONS          20 // (20)  number of training iterations
#define TOTAL_ITERATIONS        50 // (100) number of HMMs
#define NOTEST                  10 // (10) k for k-fold cross validation
#define NORR                 60000 // number of random relations

// -------------------------------------------------------------
#define HMM_size                20 // (20)
#define NOPARTS                  3 // (3) number of iner HMMs
#define SAVE        0
#define LOAD        1
#define FALSE       0
#define TRUE        1
#define NOREG    2000 // 694
#define NOF         4
#define NOE        30
#define NOG      6300
#define NOTH        3
#define NOTP        2
#define TSSIZE  40000 // 22000 // training seq. size
#define MAXSQSZ    30 // max sequence size
#define MAXEPN     20 // max num of eps
#define MAXEP      10 // max num of eps
#define MAXEPSZ   100 // max Episod Size!! (test range %)
#define SLEN        3 // 3, minimum Episod size
#define BST         8
#define BADSCORE   10
#define MAXBADSCORE 25
#define NOOS        9 // number of observation symboles
#define MAP_SIZE   50
#define NOVALUES   13
#define O_size     25
#define AHMMSZ                 1.0 // actual hmm size(nof)
#define NOEPISODE  30
#define LENGHT      0
#define TYPE        1
#define AA          0 // A Ep. in A Sequ.
#define RR          1 // R Ep. in R sequ.
#define NN          2 // Random reg. Relation
#define AR          2 // A Ep. in R Sequ.
#define RA          3 // R Ep. in A sequ.
#define AAt         4 // A Ep. in A t Sequ.
#define RRt         5 // R Ep. in R t sequ.
#define ARt         6 // A Ep. in R t Sequ.
#define RAt         7 // R Ep. in A t sequ.
#define TRAIN       0
#define TEST        1
#define POINT       0
#define LINE        1
#define LEARN       2
#define LEARN       2
#define _MIN        0
#define _AVG        1
#define _MAX        2
#define _SDV        3
#define _SCL        4
#define _SIZ        5
#define RS          9
#define RE         10
#define ES         11
#define EE         12

#define XR          1
#define XG          2

extern ofstream fgout;

class ORF {
public:
  string   name;
  float    eLevel[NOF][NOE];  // expression value, wo norm, then w norm
  int      catLev[NOF][NOE];  // takes the values of -20, -10, 0, 10, or 20
  unsigned valid [NOF][NOE];  // it is FALSE for missing values
  unsigned noe   [NOF];       // number of expressions in file f.
  unsigned maxIDX[NOF];       // index of the max value for file f
  unsigned minIDX[NOF];       // index of the min value for file f
  float    max[NOF];          // the max value for the ORF in file f
  float    min[NOF];          // the min value for the ORF in file f 

  ORF();
  void display(int f, ofstream &fout);
};

class Rr {
public:
  int  reg;
  int  tar;
  char type;

  int  vld[NOF][MAXSQSZ];
  int  seq[NOF][MAXSQSZ];

  int   eCount[MAXEPSZ];
  int   eCountF[MAXEPSZ][NOF];
  int   noep[NOF];                  // number of episodes
  int   ep[NOF][MAXEP][MAXEPSZ];    // file, num of eps., ep sequ.
  int   epSize[NOF][MAXEP];
  int   epStart[NOF][MAXEP];
  int   epEnd[NOF][MAXEP];

  float Score3[NOF][TOTAL_ITERATIONS];
  float Score2f[NOF];
  float Score2i[TOTAL_ITERATIONS];
  float Score1;

  int  epN[NOF][MAXEPN][SLEN];    // file, num of eps., ep sequ.
  int  noepN[NOF];

  float score[8][NOF][MAXEP];
  int   counter[16];
  float scoreAvr[16];

  Rr();
};

class ExpressionData {
public:
  string   namesFile;
  string   rrFile;
  string   expFile[NOF];
  ORF     *orf;
  unsigned noe   [NOF];       // number of expressions in file f.
  int      sz[NOF];
  Rr       *rr[4];
  int      rrSZ[4];
  unsigned numberOfGenes;

  // unsigned numberOfExpressions[NOF];
  float midL;
  float widL;

  ExpressionData(float ml, float wl); 
  void readExpData();
  void readRR();
  void normolizExpData();
  void quality();
  void discritize();
  void display (int f);
  void displayRR();
  void displayRRScores(int r, int tt);
  int comp(string s1, string s2);
  int inNames(string g);
  float rnd();
  float rnd(float mx);
}; // ExpressionData

class Tuple {
public:
  int      sumL  [NOF][NOE];  // 
  float    mulL  [NOF][NOE];  // 
  unsigned validL[NOF][NOE];  // it is FALSE for missing values
  unsigned noe   [NOF];       // number of expressions in file f.
  int      mp[100];           // maps old state to new one idx = oState, pam[idx] = nState
  int      pm[MAP_SIZE];      // maps new state to old one idx = nState, map[idx] = oState
  int      epesods[NOEPISODE][MAXSQSZ]; // ??? [][0]: Length, [][1]: type
  int      lastEpisode; // up to but not eq

  int rp;
  int tp;
  int rg; // reg relation global
  int ti; // type index
  int psz;
  ExpressionData *ed;

  Tuple(ExpressionData *e);
  ~Tuple();
  void createRR();
  void join (ORF &r, ORF &t);
  void scan();
  void scanTD(char type); // Training Data
  void reSymble(Rr &rr);
};

class HMM {
public:
  ExpressionData *ed;
  ofstream fout;

  int   learned;
  float pld;
  int   noVals;             // Number of diffrent posible observation values
  int   osize;
  int   tp;
  int   fl;
  int   iit;
  int   bdsq;

  //  int   pointSc[4][3][PSSIZE + 1];
  int   testNum;            // init 0
  int   testSize[3];
  int   testRR[3][NORR];    // init -1
  int   testFree[3][NORR];  // init seq.
  int   testFreeSz[3];      // init total size

  int   *trainSeq[NOTEST+1][3][NOF];                     // training sequences
  float hmmScore[NOTEST+1][TOTAL_ITERATIONS][3][NOF][2]; // HMMs scores
  int   goodHMMs[NOTEST+1][TOTAL_ITERATIONS][2][NOF];    // indexes of good HMMs
  int   fileIIT[NOF];
  int   iitMax;
  float tItr;

  int   ePointer[NOTEST+1][3][NOF];  // actual size of each training seq.
  int   O[TSSIZE];

  float alpha   [HMM_size][TSSIZE];           // Forward Algo. (P1)
  float C[TSSIZE];
  float beta    [HMM_size][TSSIZE];           // Backward Algo.(P1)
  float gama    [HMM_size][TSSIZE];           // (P3)
  float epsenon [HMM_size][HMM_size][TSSIZE]; // (P3)

  float Am[NOTEST+1][TOTAL_ITERATIONS][2][NOF][HMM_size][HMM_size];
  float Bm[NOTEST+1][TOTAL_ITERATIONS][2][NOF][HMM_size][NOVALUES];
  float Pm[NOTEST+1][TOTAL_ITERATIONS][2][NOF][HMM_size];

  float Amax[HMM_size][HMM_size];
  float Bmax[HMM_size][NOVALUES];
  float Pmax[HMM_size];

  unsigned scores[8][MAXEPSZ + 1];//[AA/RR/AR/RA][100]
  unsigned scoreColP[4][MAXEPSZ + 1];
  float    sAvrg [8];
  float    sMin  [8];
  float    sMax  [8];
  int      pAvrg[8];
  int      noep[8];
  float scoreCol[NORR][8];
  float scoreAvr[NORR][8];
  int   flg[3][NORR][8];
  float fsc[12];
  float osc[12];
  float bMin;
  float bMax;
  float bRange;


  HMM (ExpressionData *e, int argc, char flname[], char loadSave[]);
  void  hmm(int argc, char flname[], char loadSave[]);
  void  generateScores(int sft);
  void  setupDisplay();
  void  seqSetup(ofstream &fcout);
  void  testSetup();
  void  testInit();
  void  filterHMMs(ofstream &fcout, int skip);
  void  clearScores();

  void  saveMax();
  void  loadMax();
  void  save(char tms[]);
  int   load(char tms[]);
  float rnd();
  float rnd(float mx);
  void  initR();              // init HMM param Random
  void  initR2(int noParts);  // init HMM param Random
  void  trainHMM(ofstream &fcout);
  void  initLearn(ofstream &fcout);
  void  setO(int *o);
  float polanda();
  float scoreEp();
  float scoreSq(int sset, int r);
  void  calcGamaEpsenon ();
  float calcAlpha();
  void  calcBeta();
  void  displayA();
  void  displayAlpha();
  void  displayBeta();
  void  display(ofstream &fcout);
  void  displayScores(ofstream &fcout, int sset);
  void         tTest(ofstream &fcout, int iitmax);
  void        wtTest(ofstream &fcout, int iitmax);
  void  countingTest(ofstream &fcout, int iitmax);
};

/*
class MotifMatrix71 {
public:
  int mmTOee[NOG];
  int omUp[NOG][71];
  int omDown[NOG][71];
  int noo;
  int nom;
  ExpressionData *ed;

  MotifMatrix71(ExpressionData *e);
  void readMotifMatrix(string mmFile);
};

class MotifMatrix356 {
public:
  int mmTOee[NOG];
  int om[NOG][356];
  int noo;
  int nom;
  ExpressionData *ed;

  MotifMatrix356(ExpressionData *e);
  void readMotifMatrix(string namesFile, string mmFile);
};

class ChipChip {
public:
  int regs[115];
  float pvalue[6300][115];
  int nor;
  int noo;
  ExpressionData *ed;

  ChipChip(ExpressionData *e);
  void readChipChip(string fname);
};
*/

#endif
