#include "grn.h"

HMM::HMM (ExpressionData *e, int argc, char flname[], char loadSave[]) {
  cerr << "\n  PDM: ver. 3.0,  Oct. 27 2006" << endl;
  ed = e;
  bdsq = 0;
  hmm(argc, flname, loadSave);
}
  
void HMM::hmm (int argc, char flname[], char loadSave[]) {
  int  tmpSZ;
  int  tmpS;
  int  tmpE;
  int  tmpR;
  int  tmpT;
  char tmpTypeE;
  char tmpTypeS;
  char ch;
  char *flnm;
  
  int loadResult;
  int typ;
  int svLd;

  ofstream ofs;
  ofs.open("out");

  if (argc < 3) 
    svLd = LOAD;
  else if (loadSave[0] != 's' && loadSave[0] != 'S') 
    svLd = LOAD;
  else {
    svLd = SAVE;
    for (int nt = 0; nt <= NOTEST; nt++) {
      for (int t = 0; t < NOTP; t++) {
	for (int f = 0; f < NOF; f++) {
	  trainSeq[nt][t][f] = new int[TSSIZE];
	}
      }
    }
  } 

  srand((unsigned) time(0));
  noVals = 11;
  learned = FALSE;
  for (int tt = 0; tt < 2; tt++) {
    for (int r = 0; r < ed->rrSZ[tt]; r++) {
      ed->rr[tt][r].scoreAvr[tt] = 0;
      ed->rr[tt][r].counter[tt]  = 0;
    }
  }
  // ================================= Iterate =====================
  if (svLd == SAVE) {
    cerr << "\n  Training the PDM machine\n" << endl;
    testInit();
    for (iit = 0; iit < TOTAL_ITERATIONS; iit++) {
      cerr << "\tHMM/" << TOTAL_ITERATIONS
	   << "\tK/" << NOTEST
	   << "\ttype\t"
	   << "\tfile/"
	   << "\tSeqSize\tp0\tp" << MAX_ITERATIONS << endl;
      for (testNum = 0; testNum < NOTEST; testNum++) {
	if (iit == 0) {
	  testSetup();
	  seqSetup(ofs);
	}
	trainHMM(ofs);
      }
    } // =============================================================
    cerr << "\tHMM/" << TOTAL_ITERATIONS
	 << "\tnoCrV"
	 << "\ttype\t"
	 << "\tfile/" 
	 << "\tSeqSize\tp0\tp" << MAX_ITERATIONS << endl;
    testNum = NOTEST;
    for (iit = 0; iit < TOTAL_ITERATIONS; iit++) {
      seqSetup(ofs);
      trainHMM(ofs);
    }
    save(flname);
    learned = TRUE;
  } else {
    if (argc > 1)
      learned = load(flname);
    else
      learned = load("data");
  }
  if (learned == TRUE) {
    iitMax = TOTAL_ITERATIONS;
    for (fl = 0; fl < NOF; fl++) {
      fileIIT[fl] = TOTAL_ITERATIONS;
      for (int it1 = 0; it1 <  TOTAL_ITERATIONS; it1++) {
	for (int t = 0; t < 2; t++) {
	  for (int tstn = 0; tstn <= NOTEST; tstn++) {
	    goodHMMs[tstn][it1][t][fl] = it1; //TOTAL_ITERATIONS - 1 - it1;
	  }
	}
      }
    }
    // ------------------ Generating Scores ------------------------
    for (int sset = 0; sset < 1; sset++) { // sset = 0 --> average; 1 --> max
      clearScores();
      cerr << "\n\tGenerating Scores set(" << sset << ")" << endl;
      for (tp = 0; tp < NOTP; tp++) {
	for (testNum = 0; testNum < NOTEST; testNum++) {
	  generateScores(sset);
	}
      }
      tp = 3;
      testNum = NOTEST;
      generateScores(sset);
      displayScores(ofs, sset);
    }
  }
  ofs.close();
} // hmm

void HMM::clearScores() {
  for (int st = 0; st < 4; st++) {
    for (int r = 0; r < ed->rrSZ[st]; r++) {
      for(int fl = 0; fl < NOF; fl++) {
	for (int i = 0; i <  TOTAL_ITERATIONS; i++) {
	ed->rr[st][r].Score3[fl][i] = 0.0;
	}
      }
      for(int fl = 0; fl < NOF; fl++) {
	ed->rr[st][r].Score2f[fl] = 0.0;
      }
      for (int i = 0; i <  TOTAL_ITERATIONS; i++) {
	ed->rr[st][r].Score2i[iit] = 0.0;
      }
      ed->rr[st][r].Score1 = 0.0;
    }
  }
}

void HMM::testInit() {
  // -------------------------------------------- init test
  testNum = -1;
  testFreeSz[AA] = testFreeSz[RR] = testFreeSz[NN] = 0;
  for (int tt = 0; tt < 2; tt++) {
    for (int r = 0; r < ed->rrSZ[tt]; r++) {
      testRR[tt][r] = -1;
      testFree[tt][r] = testFreeSz[tt];
      testFreeSz[tt]++;
    }
    testSize[tt] = 1 + ed->rrSZ[tt] / NOTEST;
  }
  // -------------------------------------------- end init test
}

void HMM::testSetup() {
  int tst;
  // cout << "testNum:\t" << testNum << endl;
  for (int tt = AA; tt < NOTP; tt++) {
    if (testSize[tt] < testFreeSz[tt]) {
      for (int i = 0; i < testSize[tt]; i++) {
	tst = int(rnd(testFreeSz[tt]-1));
	testRR[tt][testFree[tt][tst]] = testNum;
	testFree[tt][tst] = testFree[tt][testFreeSz[tt]-1];
	testFreeSz[tt]--;
      }
    } else {
      for (int i = 0; i < testFreeSz[tt]; i++) {
	testRR[tt][testFree[tt][i]] = testNum;
      }
      testFreeSz[tt] = 0;
    }
  }
}

void HMM::seqSetup(ofstream &fcout) {
  int tt;
  if (testNum != NOTEST) {
    for (tt = AA; tt < 2; tt++) {
      for (int f = 0; f < NOF; f++) {
	ePointer[testNum][tt][f] = 0;
      }
      for (int r = 0; r < ed->rrSZ[tt]; r++) {
	if (testRR[tt][r] != testNum) {
	  for (int f = 0; f < NOF; f++) {
	    for (int p = 0; p < ed->rr[tt][r].noep[f]; p++) {
	      trainSeq[testNum][tt][f][ePointer[testNum][tt][f]] = 9;
	      ePointer[testNum][tt][f]++;
	      for (int e = 0; e < ed->rr[tt][r].epSize[f][p]; e++) {
		trainSeq[testNum][tt][f][ePointer[testNum][tt][f]] = 
		  ed->rr[tt][r].ep[f][p][e];
		ePointer[testNum][tt][f]++;
	      }
	      trainSeq[testNum][tt][f][ePointer[testNum][tt][f]] = 10;
	      ePointer[testNum][tt][f]++;
	    } // p
	  } // f
	} // if testRR
      } // r
    } // tt
  } else {
    cerr << endl;
    for (tt = AA; tt < NOTP; tt++) {
      // cerr << " --- tt:\t" << tt << "\tnorr:\t" << ed->rrSZ[tt] << endl;
      for (int f = 0; f < NOF; f++) {
	ePointer[testNum][tt][f] = 0;
      }
      for (int r = 0; r < ed->rrSZ[tt]; r++) {
	for (int f = 0; f < NOF; f++) {
	  for (int p = 0; p < ed->rr[tt][r].noep[f]; p++) {
	    trainSeq[testNum][tt][f][ePointer[testNum][tt][f]] = 9;
	    ePointer[testNum][tt][f]++;
	    for (int e = 0; e < ed->rr[tt][r].epSize[f][p]; e++) {
	      trainSeq[testNum][tt][f][ePointer[testNum][tt][f]] = 
		ed->rr[tt][r].ep[f][p][e];
	      ePointer[testNum][tt][f]++;
	    }
	    trainSeq[testNum][tt][f][ePointer[testNum][tt][f]] = 10;
	    ePointer[testNum][tt][f]++;
	  } // p
	} // f
      } // r
    }
  }
  noVals = 11;
  // info();
}

void HMM::trainHMM(ofstream &fcout) {
  int ttp;
  int otmp[TSSIZE];
  learned = TRUE;
  for (tp = 0; tp < 2; tp++) {
    for (fl = 0; fl < NOF; fl++) {
      osize = ePointer[testNum][tp][fl];
      for (int e = 0; e < osize; e++) {
	otmp[e] = trainSeq[testNum][tp][fl][e];
      }
      setO(otmp);
      initLearn(fcout);
    }
  }
} // trainHMM

void HMM::initLearn(ofstream &fcout) { // int t) {
  string Fls[] = {"CDC15", "Alpha", "CDC28", "Elu"};
  string Tp[]  = {"Activation", "Repression"};

  float A[HMM_size][HMM_size];
  float B[HMM_size][NOVALUES];
  float P[HMM_size];
  float gamaSum;
  float gamaSum2;
  float gamaSumK;
  float epSum;
  float mn;
  float pld0;

  initR2(NOPARTS);
  calcAlpha();
  calcBeta();
  calcGamaEpsenon();
  pld0 = pld = polanda() /osize;
  mn = 1000000000;
  for (int it = 0; it < MAX_ITERATIONS; it++) {
    // -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= calculate new A B P
    for (int i = 0; i < HMM_size; i++) {
      P[i] = gama[i][0] / C[0];  // ------------------------------------------- (Eq. 40)
    }
    for (int i = 0; i < HMM_size; i++) {
      gamaSum = 0;
      for (int t = 0; t < osize; t++) {
	gamaSum += gama[i][t];
      }
      gamaSum2 = 0;
      for (int t = 0; t < (osize-1); t++) {
	for (int l = 0; l < HMM_size; l++) {
	  gamaSum2 += alpha[i][t] * Am[testNum][iit][tp][fl][i][l] * 
	    Bm[testNum][iit][tp][fl][l][O[t+1]] * beta[l][t+1];
	}
      }
      for (int k = 0; k < noVals; k++) {
	gamaSumK = 0;
	for (int t = 0; t < osize; t++) {
	  if (O[t] == k)
	    gamaSumK += gama[i][t];
	}
	if (gamaSum == 0) {
	  B[i][k] = 0.0001;
	} else
	  B[i][k] = gamaSumK / gamaSum; // ------------------------- (Eq. 42)
      }
      for (int j = 0; j <  HMM_size; j++) {
	epSum = 0;
	for (int t = 0; t < (osize - 1); t++) {
	  epSum += epsenon[i][j][t];
	}

	if (gamaSum2 == 0.0) {
	  A[i][j] = 0.0001;
	} else
	  A[i][j] = epSum / gamaSum2;                     // ------------ (Eq. 41)
      }
    } // for i
    // -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= END calculate new A B P
    for (int i = 0; i < HMM_size; i++) {
      Pm[testNum][iit][tp][fl][i] = P[i];
      for (int j = 0; j <  HMM_size; j++) {
	Am[testNum][iit][tp][fl][i][j] = A[i][j];
      }
      for (int v = 0; v < noVals; v++) {
	Bm[testNum][iit][tp][fl][i][v] = B[i][v]; 
      }
    }
    calcAlpha();
    calcBeta();
    calcGamaEpsenon();
    pld = polanda()/osize;
    if (it > (MAX_ITERATIONS * 0.6) && pld < mn) {
      mn = pld;
      saveMax();
    }
  } // it
  loadMax();
  pld = polanda()/osize;

  cerr << '\t' << iit  << '\t';
  if (testNum >= 0)
    cerr << testNum;
  else
    cerr << 'X';
  cerr << '\t' << Tp[tp] 
       << '\t' << Fls[fl]   << '\t' << osize 
       << '\t' << pld0 << '\t' << pld << endl;
} // initLearn

float HMM::calcAlpha() {
  float segma;
  float alphaSum;
  float cSum;
  alphaSum = 0;
  cSum = 0.0;
  for (int i = 0; i < HMM_size; i++) { // ------------------------- [06]
    alpha[i][0] = Pm[testNum][iit][tp][fl][i] * Bm[testNum][iit][tp][fl][i][O[0]];
    alphaSum += alpha[i][0];
  }
  C[0] = 1.0 / alphaSum;
  for (int i = 0; i < HMM_size; i++) { // ------------------------- [06]
    alpha[i][0] = alpha[i][0] * C[0];
  }
  for (int t = 1; t < osize; t++) {    // ------------------------- [07]
    alphaSum = 0;
    for (int j = 0; j < HMM_size; j++) {
      segma = 0;
      for (int i = 0; i < HMM_size; i++) {
	segma += alpha[i][t-1] * Am[testNum][iit][tp][fl][i][j];
      }
      alpha[j][t] = segma * Bm[testNum][iit][tp][fl][j][O[t]];
      alphaSum += alpha[j][t];
    }
    if (alphaSum == 0.0) {
      cerr << " -=-=-=-=-=-=-=-=-=-= Error alphaSum = 0"
	   << ", iit = " << iit << ", tp = " << tp
	   << ", testNum = " << testNum << endl;
      return -100;
    } else {
      C[t] = 1.0 / alphaSum;
    }
    for (int j = 0; j < HMM_size; j++) {
      alpha[j][t] = alpha[j][t] * C[t];
    }
    cSum += log(C[t]);
  }
  return cSum;
}

void HMM::calcBeta() {
  for (int i = 0; i < HMM_size; i++) { // ------------------------- [11]
    beta[i][osize-1] = C[osize-1];
  }
  for (int t = osize - 2; t >= 0; t--) { // ----------------------- [12]
    for (int i = 0; i < HMM_size; i++) {
      beta[i][t] = 0;
      for (int j = 0; j < HMM_size; j++) {
	beta[i][t] += Am[testNum][iit][tp][fl][i][j] * 
	  Bm[testNum][iit][tp][fl][j][O[t+1]] * beta[j][t+1];
      }
      beta[i][t] = beta[i][t] * C[t];
    }
  }
}

float HMM::polanda() {
  float la = 0;
  for (int t = 0; t < osize; t++) { // ------------------------- [08]
    la += log(C[t]);
  }
  return la;
}

void HMM::calcGamaEpsenon () {
  float po;
  for (int i = 0; i < HMM_size; i++) { // ------------------------- [31]
    for (int t = 0; t < osize; t++) {
      gama[i][t]    = alpha[i][t] * beta[i][t];
    }
  }
  for (int i = 0; i < HMM_size; i++) { // ------------------------- [39]
    for (int t = 0; t < (osize - 1); t++) {
      for ( int j = 0; j < HMM_size; j++) {
	epsenon[i][j][t] = alpha[i][t] * beta[j][t+1] *
	  Am[testNum][iit][tp][fl][i][j] * Bm[testNum][iit][tp][fl][j][O[t+1]];
      }
    } // t
  } // i
}

void HMM::setO(int *o) {
  for (int i = 0; i < osize; i++) {
    O[i] = o[i];
  }
}

void HMM::initR() {  // init HMM param
  float sumRnd;
  // ------------------------------------------------------------- init A:
  for (int i = 0; i < HMM_size; i++) { 
    for (int j = 0; j < HMM_size; j++) {
      if (i <= j)
	Am[testNum][iit][tp][fl][i][j] = rnd();
      else
	Am[testNum][iit][tp][fl][i][j] = 0.0;
      if ((i == HMM_size - 1) && j == 0)
	Am[testNum][iit][tp][fl][i][j] = 1.0;
    }
    sumRnd = 0.0;
    for (int j = 0; j < HMM_size; j++) {
      sumRnd += Am[testNum][iit][tp][fl][i][j];
    }
    for (int j = 0; j < HMM_size; j++) {
      Am[testNum][iit][tp][fl][i][j] = Am[testNum][iit][tp][fl][i][j] / sumRnd;
    }
  }
  displayA();
  // ---------------------------------------------------------- init B:
  for (int v = 0; v < noVals - 2; v++) {
    Bm[testNum][iit][tp][fl][0][v] = 0.0;
    Bm[testNum][iit][tp][fl][HMM_size-1][v] = 0.0;
  }
  Bm[testNum][iit][tp][fl][0][9] = 1.0;
  Bm[testNum][iit][tp][fl][HMM_size-1][10] = 1.0;
  for (int i = 1; i < HMM_size - 1; i++) {
    for (int v = 0; v < noVals - 2; v++) {
      Bm[testNum][iit][tp][fl][i][v] = rnd();
    }
    for (int v = noVals - 2; v < noVals; v++) {
      Bm[testNum][iit][tp][fl][i][v] = 0.0;
    }
  }
  for (int i = 1; i < HMM_size - 1; i++) {
    sumRnd = 0.0;
    for (int v = 0; v < noVals; v++) {
      sumRnd += Bm[testNum][iit][tp][fl][i][v]; 
    }
    for (int v = 0; v < noVals; v++) {
      Bm[testNum][iit][tp][fl][i][v] = Bm[testNum][iit][tp][fl][i][v] / sumRnd;
    }
  }

  // --------------------------------------------------------- init P:
  sumRnd = 0.0;
  for (int i = 0; i < HMM_size; i++) { 
    Pm[testNum][iit][tp][fl][i] = 0.0;
  }
  Pm[testNum][iit][tp][fl][0] = 1.0;
  for (int i = 0; i < HMM_size; i++) {
    sumRnd += Pm[testNum][iit][tp][fl][i];
  }
  for (int i = 0; i < HMM_size; i++) {
     Pm[testNum][iit][tp][fl][i] = Pm[testNum][iit][tp][fl][i] / sumRnd;
  }
} // initR

void HMM::displayA() {
  for (int i = 0; i < HMM_size; i++) { 
    for (int j = 0; j < HMM_size; j++) {
      if (Am[testNum][iit][tp][fl][i][j] > 0)
	cerr << 'x' << '\t';
      else
	cerr << '0' << '\t';
    }
    cerr << endl;
  }
  cerr << endl;
}

void HMM::initR2(int noParts) {  // init HMM param
  float sumRnd;
  int pSz = (HMM_size - 2)/ noParts;
  if ((noParts * pSz + 2) != HMM_size)
    cerr << " -- ((HMM_size - 2) mode NOPARTS) must be equal to Zero -------------" << endl;
  // ------------------------------------------------------------- init A:
  for (int i = 0; i < HMM_size; i++) { 
    for (int j = 0; j < HMM_size; j++) {
      Am[testNum][iit][tp][fl][i][j] = 0.0;
    }
  }
  for (int i = 1; i < (HMM_size - 1); i++) { 
    Am[testNum][iit][tp][fl][0][i] = rnd();
    Am[testNum][iit][tp][fl][i][HMM_size - 1] = rnd();
  }
  Am[testNum][iit][tp][fl][HMM_size - 1][0] = 1.0;

  for (int k = 0; k < noParts; k++) { 
    for (int i = (1 + k * pSz); i < (1 + (k + 1) * pSz); i++) { 
      for (int j = i; j < (1 + (k + 1) * pSz); j++) {
	Am[testNum][iit][tp][fl][i][j] = rnd();
      }
    } // i
  } // k

  for (int i = 0; i < HMM_size; i++) { 
    sumRnd = 0.0;
    for (int j = 0; j < HMM_size; j++) {
      sumRnd += Am[testNum][iit][tp][fl][i][j];
    }
    for (int j = 0; j < HMM_size; j++) {
      Am[testNum][iit][tp][fl][i][j] = Am[testNum][iit][tp][fl][i][j] / sumRnd;
    }
  } // for i
  // displayA();
  // ---------------------------------------------------------- init B:
  for (int v = 0; v < noVals - 2; v++) {
    Bm[testNum][iit][tp][fl][0][v] = 0.0;
    Bm[testNum][iit][tp][fl][HMM_size-1][v] = 0.0;
  }
  Bm[testNum][iit][tp][fl][0][9] = 1.0;
  Bm[testNum][iit][tp][fl][HMM_size-1][10] = 1.0;
  for (int i = 1; i < HMM_size - 1; i++) {
    for (int v = 0; v < noVals - 2; v++) {
      Bm[testNum][iit][tp][fl][i][v] = rnd();
    }
    for (int v = noVals - 2; v < noVals; v++) {
      Bm[testNum][iit][tp][fl][i][v] = 0.0;
    }
  }
  for (int i = 1; i < HMM_size - 1; i++) {
    sumRnd = 0.0;
    for (int v = 0; v < noVals; v++) {
      sumRnd += Bm[testNum][iit][tp][fl][i][v]; 
    }
    for (int v = 0; v < noVals; v++) {
      Bm[testNum][iit][tp][fl][i][v] = Bm[testNum][iit][tp][fl][i][v] / sumRnd;
    }
  }

  // --------------------------------------------------------- init P:
  sumRnd = 0.0;
  for (int i = 0; i < HMM_size; i++) { 
    Pm[testNum][iit][tp][fl][i] = 0.0;
  }
  Pm[testNum][iit][tp][fl][0] = 1.0;
  for (int i = 0; i < HMM_size; i++) {
    sumRnd += Pm[testNum][iit][tp][fl][i];
  }
  for (int i = 0; i < HMM_size; i++) {
     Pm[testNum][iit][tp][fl][i] = Pm[testNum][iit][tp][fl][i] / sumRnd;
  }
} // initR2

float HMM::scoreEp() {
  float sc;
  float pld;
  int sz;
  float ret;
  int oldTp = tp;
  int oldIit = iit;
  sz = osize - 1;
  tp = 0;
  ret = 0.0;
  iit = goodHMMs[testNum][oldIit][tp][fl];
  if (-100 < (pld = calcAlpha())) {
    sc = exp(0.0 - (pld / sz));
    tp = 1;
    iit = goodHMMs[testNum][oldIit][tp][fl];
    if (-100 < (pld = calcAlpha())) {
      ret = sc - exp(0.0 - (polanda() / sz));
    } else {
      bdsq++;
    }
  } else {
    bdsq++;
  }
  tp  = oldTp;
  iit = oldIit;
  return ret;
}

void HMM::generateScores(int sset) {
  int st; // sequences type
  int fe;
  float wt[4];

  wt[0] = wt[1] = 0.9;
  wt[2] = wt[3] = 1.1;

  st = tp;
  for (int r = 0; r < ed->rrSZ[st]; r++) {
    if ((st == 3) || (testRR[st][r] == testNum)) {
      ed->rr[st][r].Score1 = 0;
      for (fl = 0; fl < NOF; fl++) {
	if (ed->rr[st][r].noep[fl] > 0) {
	  scoreSq(sset, r);
	}
      }
    } // if
  }

  for (int r = 0; r < ed->rrSZ[st]; r++) {
    if ((st == 3) || (testRR[st][r] == testNum)) {
      for (int i = 0; i < iitMax; i++) {
	fe = 0;
	ed->rr[st][r].Score2i[i] = 0;
	for (fl = 0; fl < NOF; fl++) {
	  if (ed->rr[st][r].noep[fl] > 0) {
	    fe++;
	    ed->rr[st][r].Score2i[i] += (ed->rr[st][r].Score3[fl][i] * wt[fl]);
	  }
	}
	if (fe > 0)
	  ed->rr[st][r].Score2i[i] = ed->rr[st][r].Score2i[i] / fe;
	else 
	  ed->rr[st][r].Score2i[i] = 0;

	if (sset == 0 && i > 0)
	  ed->rr[st][r].Score2i[i] = (ed->rr[st][r].Score2i[i] + 
				      ed->rr[st][r].Score2i[i-1] * i) / float(i + 1);
      } // i
      ed->rr[st][r].Score1 += ed->rr[st][r].Score2i[iitMax - 1];
    } // if
  } // r

  /*
  for (int r = 0; r < ed->rrSZ[st]; r++) {
    if ((st == 3) || (testRR[st][r] == testNum)) {
      if (sset < 2) {
	for (int i = 0; i < iitMax; i++) {
	  ed->rr[st][r].Score1 += ed->rr[st][r].Score2i[iitMax];
	}
	ed->rr[st][r].Score1 = ed->rr[st][r].Score1 / iitMax;
      } else {
	fe = 0;
	for (int f = 0; f < NOF; f++) {
	  if (ed->rr[st][r].noep[f] > 0) {
	    ed->rr[st][r].Score1 += ed->rr[st][r].Score2f[f];
	    fe++;
	  }
	}
	ed->rr[st][r].Score1 = ed->rr[st][r].Score1 / fe;
      }
    } // if
  } // r
  */
}

float HMM::scoreSq(int sset, int r) {
  int   otmp[MAXEPSZ];
  int   st = tp;
  float epScores[2][MAXEPN][MAXEPSZ+2][TOTAL_ITERATIONS];

  float ret3[TOTAL_ITERATIONS];
  int   retCounter3[TOTAL_ITERATIONS];
  float ret2[MAXEPSZ];
  int   retCounter2[MAXEPSZ];
  float ret1[MAXEPN];
  int   retCounter1[MAXEPN];
  int   retCounter0[TOTAL_ITERATIONS];
  float ret[2];
  int   retCounter[2];
  int   oldTp = tp;
  int   sz;
  int   iii;
  int   noiit;

  otmp[0] = 9;
  ed->rr[st][r].Score2f[fl] = 0.0;
  if (sset == 0) { // -------------------------------- Old Scoring
    noiit = 0;
    ed->rr[st][r].Score2f[fl] = 0.0;
    for (iit = 0; iit < fileIIT[fl]; iit++) {
      if (ed->rr[st][r].noep[fl] > 0) {
	noiit++;
	ed->rr[st][r].Score3[fl][iit] = 0;
	for (int p = 0; p < ed->rr[st][r].noep[fl]; p++) {
	  for (int e = 0; e < ed->rr[st][r].epSize[fl][p]; e++) {
	    otmp[e + 1] = ed->rr[st][r].ep[fl][p][e];
	  }
	  otmp[ed->rr[st][r].epSize[fl][p] + 1] = 10;
	  osize = ed->rr[st][r].epSize[fl][p] + 2;
	  setO(otmp);
	  ed->rr[st][r].Score3[fl][iit] += scoreEp();
	} // p
	ed->rr[st][r].Score3[fl][iit] = ed->rr[st][r].Score3[fl][iit] / 
	  ed->rr[st][r].noep[fl];
	ed->rr[st][r].Score2f[fl] += ed->rr[st][r].Score3[fl][iit]; 
      }
    } // iit
    if (noiit > 0)
      ed->rr[st][r].Score2f[fl] = ed->rr[st][r].Score2f[fl] / noiit;
  } else { // -------------------------------------- Test Scoring
    for (iit = 0; iit < fileIIT[fl]; iit++) {
      for (int p = 0; p < ed->rr[st][r].noep[fl]; p++) {
	for (int e = 0; e < ed->rr[st][r].epSize[fl][p]; e++) {
	  otmp[e + 1] = ed->rr[st][r].ep[fl][p][e];
	}
	otmp[ed->rr[st][r].epSize[fl][p] + 1] = 10;
	osize = ed->rr[st][r].epSize[fl][p] + 2;
	setO(otmp);
	for (tp = 0; tp < 2; tp++) {
	  calcAlpha();
	  for (int e = 1; e <= (ed->rr[st][r].epSize[fl][p] + 1); e++) {
	    epScores[tp][p][e][iit] = log(C[e]); // sqrt((1.0 / C[e])); // log(C[e]);
	    epScores[tp][p][e][iit] = epScores[tp][p][e][iit] * epScores[tp][p][e][iit];
	  }
	}
      } // p 
    } // iit

    for (int p = 0; p < ed->rr[st][r].noep[fl]; p++) {
      for (tp = 0; tp < 2; tp++) {
	for (int e = 1; e <= (ed->rr[st][r].epSize[fl][p] + 1); e++) {
	  sort(epScores[tp][p][e], epScores[tp][p][e] + iitMax);
	}
      }
    }

    for (iit = 0; iit < iitMax; iit++) {
      ed->rr[st][r].Score3[fl][iit] = 0;
      retCounter0[iit] = 0;
      for (int p = 0; p < ed->rr[st][r].noep[fl]; p++) {
	ret1[p] = 0.0;

	for (tp = 0; tp < 2; tp++) {
	  ret2[tp] = 0.0;
	  retCounter2[tp] = 0;

	  for (int e = 1; e <= (ed->rr[st][r].epSize[fl][p] + 1); e++) {
	    ret3[e] = 0;
	    retCounter3[e] = 0;
	    for (int i = iit; i >= 0; i--) { // (iit/2)
	      ret3[e] += epScores[tp][p][e][i];
	      retCounter3[e]++;
	    }
	    ret2[tp] += ret3[e]/float(retCounter3[e]); //log(ret3[e]/float(retCounter3[e]));
	    retCounter2[tp]++;
	  }
	  ret2[tp] = ret2[tp] / retCounter2[tp];
	}

	ret1[p] = exp(0.0-ret2[AA]) - exp(0.0 - ret2[RR]);
	ed->rr[st][r].Score3[fl][iit] += ret1[p];
	retCounter0[iit]++;
      } // p
      ed->rr[st][r].Score3[fl][iit] = ed->rr[st][r].Score3[fl][iit] / retCounter0[iit];
    } // iit


    ed->rr[st][r].Score2f[fl] = ed->rr[st][r].Score3[fl][iitMax - 1]; // ?????
    tp = oldTp;
  } // if sset
}

void HMM::displayScores(ofstream &fcout, int sset) {
  float max;
  float min;
  int   st;
  int   tj;
  float plot [4][100];
  float plot2[4][100];
  float avrg[4];
  float var[4];
  int   bs[4];
  float range;
  float rg10;
  float plVal;
  float s2;
  float tval;
  float xxx;
  float threshold[NOTH];
  float stp[2][NOTH];
  string typ[2];
  typ[0] = "AA";
  typ[1] = "RR";

  threshold[0] = 0.1;
  for (int i = 1; i < NOTH; i++) {
    threshold[i] = threshold[i-1] + 0.1;
    for (int j = 0; j < 2; j++) {
      stp[j][i] = 0;
    }
  }

  fcout << "\niit\t";
  for (int j = 0; j < 2; j++) {
    for (int i = 0; i < NOTH; i++)
      fcout << typ[j] << "@" << threshold[i] * 100 << "%\t"; 
  }  
  fcout << endl << "---------------------------------------------------" << endl;
  for (int iitt = 0; iitt < iitMax; iitt++) {
    for (int i = 0; i < 4; i++) {
      avrg[i] = var[i] = bs[i] = 0;
      for (int j = 0; j < 100; j++)
	plot2[i][j] = plot[i][j] = 0;
    }
    
    max = -100.0;
    min =  100.0;
    for (st = 0; st < 2; st++) {
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
	/*
	if (iitt == iitMax - 1) {
	  fcout << ed->orf[ed->rr[st][r].reg].name << "\t" << st << "\t" 
		<< ed->orf[ed->rr[st][r].tar].name << "\t" 
		<< r << "\t" << ed->rr[st][r].Score1 << endl;
	}
	*/
	if (ed->rr[st][r].Score2i[iitt] > max)
	  max = ed->rr[st][r].Score2i[iitt];
	if (ed->rr[st][r].Score2i[iitt] < min)
	  min = ed->rr[st][r].Score2i[iitt];
      }
    }
    st = 3;
    /*
      if (iitt == iitMax - 1) {
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
      fcout << ed->orf[ed->rr[st][r].reg].name << "\t" << st << "\t" 
      << ed->orf[ed->rr[st][r].tar].name << "\t" 
      << r << "\t" << ed->rr[st][r].Score1 << endl;
      }
      fcout << endl;
      }
    */

    range = (max - min) * 1.2;
    rg10  = range / 10.0;
    
    for (st = 0; st < 4; st++) {
      if (st != 2) {
	if (st == 3 && iitt == (iitMax - 1))
	  cerr << "rr\tscore1" << endl;
	for ( int r = 0; r < ed->rrSZ[st]; r++) {
	  if (ed->rr[st][r].Score2i[iitt] > -100.0) {
	    if (r < 20 && st == 3 && iitt == (iitMax - 1)) {
	      cerr << r << '\t' << float(int(10000 * ed->rr[st][r].Score2i[iitt])) / 10000.0 << endl;
	    } 
	    // ------------------------------------------------------------
	    plVal = ed->rr[st][r].Score2i[iitt] = ed->rr[st][r].Score2i[iitt] - min + rg10;
	    if (plVal < (rg10 / 2.0)) {
	      plVal = rg10 / 2.0;
	    } else if (plVal > (range - (rg10 / 2.0))){
	      plVal = range - (rg10 / 2.0);
	    }
	    avrg[st] += ed->rr[st][r].Score2i[iitt];
	    
	    plot[st][int(99.0 * plVal / range)]++;
	    // ------------------------------------------------------------
	  } else {
	    bs[st]++;
	    cerr << "\tBad sc\t" << bs[st] << "\t" << st 
		 << "\t" << r << "\t" << avrg[st] << "\t" << ed->rr[st][r].Score2i[iitt] << endl;
	  }
	}
      } else {
	for ( int r = 0; r < ed->rrSZ[st]; r++) {
	  plVal = ed->rr[st][r].Score2i[iitt] = 0.0 - min + rg10;
	  if (plVal < (rg10 / 2.0)) {
	    plVal = rg10 / 2.0;
	  } else if (plVal > (range - (rg10 / 2.0))){
	    plVal = range - (rg10 / 2.0);
	  }
	  avrg[st] += ed->rr[st][r].Score2i[iitt];	  
	  plot[st][int(99.0 * plVal / range)]++;
	}
      }
      avrg[st] = avrg[st] / (ed->rrSZ[st] - bs[st]);
    }
    
    for (st = 0; st < 4; st++) {
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
	if (ed->rr[st][r].Score2i[iitt] > -100.0)
	  var[st] += ((ed->rr[st][r].Score2i[iitt] - avrg[st]) * (ed->rr[st][r].Score2i[iitt] - avrg[st]));
      }
      var[st] = var[st] / (ed->rrSZ[st] - 1 - bs[st]);
      // cerr << "\t("<< st << ")\tavrg:\t" << avrg[st];
      // cerr << "\tvar:\t" << var[st] << endl;
    }
    s2 = 0;
    xxx = ((ed->rrSZ[0] - 1 - bs[0]) + (ed->rrSZ[1] - 1 - bs[1]));
    s2 = (var[0]* (ed->rrSZ[0] - 1 - bs[0]) +  var[1]* (ed->rrSZ[1] - 1 - bs[1])) / xxx;
    
    tval = (avrg[0] - avrg[1]) / 
      (sqrt(s2 * (1.0/(ed->rrSZ[0] - bs[0]) + 1.0/(ed->rrSZ[1] - bs[1]))));
    
    for (int j = 0; j < 100; j++) {
      for (st = 0; st < 4; st++) {
	plot2[st][j] = plot[st][j] = plot[st][j] / float(ed->rrSZ[st]);
	if (j > 0)
	  plot2[st][j] += plot2[st][j-1];
      }
    }

    tj = 0;
    for (int j = 1; j < 100; j++) {
      if (j < 45) {
	if (tj < NOTH) {
	  if (plot2[1][j] >= threshold[tj]) {
	    stp[1][tj] = ((plot2[3][j] - plot2[3][j-1])/(plot2[1][j] - plot2[1][j-1])) *
	      (threshold[tj] - plot2[1][j-1]) + plot2[3][j-1];
	    tj++;
	  }
	}
      } else if (j > 45) {
	if (tj >= 0) {
	  if ((1.0 - plot2[0][j]) <= threshold[tj]) {
	    stp[0][tj] = 1 - (
			      ((plot2[3][j-1] - plot2[3][j]) / (plot2[0][j-1] - plot2[0][j])) *
			      ((1.0 - threshold[tj]) - plot2[0][j]) + 
			      plot2[3][j]
			      );
	    tj--;
	  }
	}
      } else {
	tj = NOTH - 1;
      }
    }

    // ----------------------- Display --------------------------
    
    fcout << iitt << "\t";
    for (int j = 0; j < 2; j++) {
      for (int i = 0; i < NOTH; i++)
	if (stp[j][i] > 0)
	  fcout << float(int((threshold[i] / stp[j][i]) * 10.0)) / 10.0 << "\t";
	else
	  fcout << "Inf.\t";
    }
    fcout << endl;

    if (iitt == iitMax - 1) {
      cerr  << "t-test:\t" << tval << endl;
      fcout << "t-test:\t" << tval << endl;
      fcout << "AA\tRR\t\tUN" << endl;
      for (st = 0; st < 4; st++)
	fcout << float(int(10000.0 * avrg[st]) / 100.0) << "\t";
      fcout << endl;
      for (st = 0; st < 4; st++)
	fcout << float(int(1000000.0 * var[st]) / 10000.0) << "\t";
      fcout << endl << "------------------------------" << endl;
      for (int j = 0; j < 100; j++) {
	for (st = 0; st < 4; st++) {
	  fcout << float(int(100000.0 * plot[st][j])) / 1000.0 << "\t";
	}
	fcout << endl;
      }
      fcout << endl;
      fcout << endl;
      fcout << "AA\tRR\t\tUN" << endl;
      fcout << "------------------------------" << endl;
      for (int j = 0; j < 100; j++) {
	for (st = 0; st < 4; st++) {
	  fcout << float(int(100000.0 * plot2[st][j])) / 1000.0 << "\t";
	}
	fcout << endl;
      }
    }
    // ----------------------------------------------------------
    // fcout << endl;
    
  }

  tTest(fcout, iitMax);
  wtTest(fcout, iitMax);
  // countingTest(fcout, iitMax);
  fcout << " Bad Sq:\t" << bdsq << endl;
}

void HMM::tTest(ofstream &fcout, int iitmax) {
  float s2 = 0;
  float tval;
  float avrg[4];
  float var[4];
  int   bs[4];

  fcout << "\nT val\t\t(A-R)\t(A-U)\t(R-U)" << endl;
  for (iit = 0; iit < iitmax; iit++) {
    fcout << "iit:\t" << iit;
    for (int st = 0; st < 4; st++) {
      avrg[st] = var[st] = bs[st] = 0;
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
	if (ed->rr[st][r].Score2i[iit] > -100.0) {
	  avrg[st] += ed->rr[st][r].Score2i[iit];
	} else {
	  bs[st]++;
	}
      }
      avrg[st] = avrg[st] /(ed->rrSZ[st] - bs[st]);
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
	if (ed->rr[st][r].Score2i[iit] > -100.0)
	  var[st] += ((ed->rr[st][r].Score2i[iit] - avrg[st]) * 
		      (ed->rr[st][r].Score2i[iit] - avrg[st]));
      }
      var[st] = var[st] / (ed->rrSZ[st] - 1 - bs[st]);
    } // for st

    s2 = (var[0]* (ed->rrSZ[0] - 1 - bs[0]) + var[1]* (ed->rrSZ[1] - 1 - bs[1])) /
      ((ed->rrSZ[0] - 1 - bs[0]) + (ed->rrSZ[1] - 1 - bs[1]));

    tval = (avrg[0] - avrg[1]) / (sqrt(s2 * (1.0/(ed->rrSZ[0] - bs[0]) + 1.0/(ed->rrSZ[1] - bs[1]))));

    fcout << "\t" << float(int(1000.0*tval))/1000.0;

    s2 = (var[0]* (ed->rrSZ[0] - 1 - bs[0]) +  var[3]* (ed->rrSZ[3] - 1 - bs[3])) /
      ((ed->rrSZ[0] - 1 - bs[0]) + (ed->rrSZ[3] - 1 - bs[3]));

    tval = (avrg[0] - avrg[3]) / (sqrt(s2 * (1.0/(ed->rrSZ[0] - bs[0]) + 1.0/(ed->rrSZ[3] - bs[3]))));

    fcout << "\t" << float(int(1000.0*tval))/1000.0;

    s2 = (var[1]* (ed->rrSZ[1] - 1 - bs[1]) +  var[3]* (ed->rrSZ[3] - 1 - bs[3])) /
      ((ed->rrSZ[1] - 1 - bs[1]) + (ed->rrSZ[3] - 1 - bs[3]));

    tval = (avrg[3] - avrg[1]) / (sqrt(s2 * (1.0/(ed->rrSZ[1] - bs[1]) + 1.0/(ed->rrSZ[3] - bs[3]))));

    fcout << "\t" << float(int(1000.0*tval))/1000.0 << endl;
  } // for iit
}

void HMM::wtTest(ofstream &fcout, int iitmax) {
  float s2 = 0;
  float tval;
  float avrg[4];
  float var[4];
  int   bs[4];

  fcout << "\nWelch t val\t(A-R)\t(A-U)\t(R-U)" << endl;
  for (iit = 0; iit < iitmax; iit++) {
    fcout << "iit:\t" << iit;
    for (int st = 0; st < 4; st++) {
      avrg[st] = var[st] = bs[st] = 0;
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
	if (ed->rr[st][r].Score2i[iit] > -100.0) {
	  avrg[st] += ed->rr[st][r].Score2i[iit];
	} else {
	  bs[st]++;
	}
      }
      avrg[st] = avrg[st] /(ed->rrSZ[st] - bs[st]);
      for ( int r = 0; r < ed->rrSZ[st]; r++) {
	if (ed->rr[st][r].Score2i[iit] > -100.0)
	  var[st] += ((ed->rr[st][r].Score2i[iit] - avrg[st]) * 
		      (ed->rr[st][r].Score2i[iit] - avrg[st]));
      }
      var[st] = var[st] / (ed->rrSZ[st] - 1 - bs[st]);
    } // for st
    tval = (avrg[0] - avrg[1]) / (sqrt(var[0] / (ed->rrSZ[0] - bs[0]) + var[1] / (ed->rrSZ[1] - bs[1])));
    fcout << "\t" << float(int(1000.0*tval))/1000.0;

    tval = (avrg[0] - avrg[3]) / (sqrt(var[0] / (ed->rrSZ[0] - bs[0]) + var[3] / (ed->rrSZ[3] - bs[3])));
    fcout << "\t" << float(int(1000.0*tval))/1000.0;

    tval = (avrg[3] - avrg[1]) / (sqrt(var[3] / (ed->rrSZ[3] - bs[3]) + var[1] / (ed->rrSZ[1] - bs[1])));
    fcout << "\t" << float(int(1000.0*tval))/1000.0 << endl;
  } // for iit
}

void HMM::saveMax() {
  for (int i = 0; i < HMM_size; i++) {
    Pmax[i] = Pm[testNum][iit][tp][fl][i];
    for (int j = 0; j <  HMM_size; j++) {
      Amax[i][j] = Am[testNum][iit][tp][fl][i][j];
    }
    for (int v = 0; v < noVals; v++) {
      Bmax[i][v] = Bm[testNum][iit][tp][fl][i][v]; 
    }
  }
}

void HMM::loadMax() {
  for (int i = 0; i < HMM_size; i++) {
    Pm[testNum][iit][tp][fl][i] = Pmax[i];
    for (int j = 0; j <  HMM_size; j++) {
      Am[testNum][iit][tp][fl][i][j] = Amax[i][j];
    }
    for (int v = 0; v < noVals; v++) {
      Bm[testNum][iit][tp][fl][i][v] = Bmax[i][v]; 
    }
  }
}

void HMM::save(char tms[]) {
  ofstream fcout;
  fcout.open(tms);

  char *ttmm;
  time_t timeN;
  time_t timeNow = time(&timeN);
  ttmm = ctime(&timeNow);

  fcout << ttmm << " X" << endl;
  fcout << NOPARTS << endl;
  fcout << NOTEST  << endl;
  fcout << TOTAL_ITERATIONS << endl;
  fcout << NOF << endl;
  fcout << HMM_size << endl;
  fcout << noVals << endl;
  fcout << MAX_ITERATIONS << endl;

  for (int st = 0; st < NOTP; st++) {
    for (int r = 0; r < ed->rrSZ[st]; r++) {
      fcout << testRR[st][r] << ' ';
    }
  }

  for (testNum = 0; testNum <= NOTEST; testNum++) {
    for (iit = 0; iit < TOTAL_ITERATIONS; iit++) {
      for (tp = 0; tp < 2; tp++) {
	for (fl = 0; fl < NOF; fl++) {
	  for (int i = 0; i < HMM_size; i++) {
	    fcout << Pm[testNum][iit][tp][fl][i] << ' ';
	    for (int j = 0; j <  HMM_size; j++) {
	      fcout << Am[testNum][iit][tp][fl][i][j] << ' ';
	    }
	    for (int v = 0; v < noVals; v++) {
	      fcout << Bm[testNum][iit][tp][fl][i][v] << ' '; 
	    }
	  }
	}
      }
    }
  }
  // -------------------
  fcout.close();
}

int HMM::load(char tms[]) {
  int notest;
  int totit;
  int numoffiles;
  int hsz;
  int nov;
  int nopart;
  int maxIterations;
  float dump;
  int result;
  string str;
  ifstream fcin;
  fcin.open(tms);

  cerr << endl << "Date ....:\t";
  fcin >> str;
  while(str[0] != 'X') {
    cerr << str << ' ';
    fcin >> str;
    // fcin >> ch;
  }
  cerr << "\nfile name:\t" << tms << endl;

  fcin >> nopart;
  fcin >> notest;
  fcin >> totit;
  fcin >> numoffiles;
  fcin >> hsz;
  fcin >> nov;
  fcin >> maxIterations;

  cerr << "\n\t\t\t\t\tfile\t\tprogram" << endl;
  cerr << "\t--------------------------------------------------------" << endl;
  cerr << "\tNumber of k-fold ............|\t" << notest        << "\t==\t" << NOTEST << endl;
  cerr << "\tNumber of HMMs ..............|\t" << totit         << "\t>=\t" << TOTAL_ITERATIONS << endl;
  cerr << "\tNumber of files .............|\t" << numoffiles    << "\t==\t" << NOF << endl;
  cerr << "\tHMM Size ....................|\t" << hsz           << "\t==\t" << HMM_size << endl;
  cerr << "\tNumber of observations ......|\t" << nov           << "\t==\t" << noVals << endl;
  cerr << "\tNumber of training iterations|\t" << maxIterations << "\t  \t" << MAX_ITERATIONS << endl;
  cerr << "\tNumber of iner HMMs .........|\t" << nopart        << "\t  \t" << NOPARTS << endl;

  if (notest == NOTEST   && totit >= TOTAL_ITERATIONS && numoffiles == NOF &&
      hsz    == HMM_size && nov   == noVals           ) {
    for (int st = 0; st < NOTP; st++) {
      for (int r = 0; r < ed->rrSZ[st]; r++) {
	fcin >> testRR[st][r];
      }
    }

    for (testNum = 0; testNum <= NOTEST; testNum++) {
      for (iit = 0; iit < totit; iit++) {
	for (tp = 0; tp < 2; tp++) {
	  for (fl = 0; fl < NOF; fl++) {
	    for (int i = 0; i < HMM_size; i++) {
	      if (iit < TOTAL_ITERATIONS)
		fcin >> Pm[testNum][iit][tp][fl][i];
	      else
		fcin >> dump;
	      for (int j = 0; j <  HMM_size; j++) {
		if (iit < TOTAL_ITERATIONS)
		  fcin >> Am[testNum][iit][tp][fl][i][j];
		else
		  fcin >> dump;
	      }
	      for (int v = 0; v < noVals; v++) {
		if (iit < TOTAL_ITERATIONS)
		  fcin >> Bm[testNum][iit][tp][fl][i][v]; 
		else
		  fcin >> dump;
	      }
	    }
	  }
	}
      }
    }
    result = TRUE;
  } else {
    cerr << " para not matched!!!" << endl;
    result = FALSE;
  }
  // -------------------

  fcin.close();
  return result;
}

float HMM::rnd(float mx) {
  return rnd() * mx;
}

float HMM::rnd() {
  float rnd;
  float mx;
  mx = RAND_MAX;
  rnd = rand();
  return rnd / mx;
}

void HMM::displayAlpha() { 
  cout << " -------- Alpha" << endl;
  for (int i = 0; i < HMM_size; i++) {
    for (int t = 0; t < osize; t++) {
      cout << alpha[i][t] << '\t';
    }
    cout << endl;
  }
}

void HMM::displayBeta() { 
  cout << " -------- Beta" << endl;
  for (int i = 0; i < HMM_size; i++) {
    for (int t = 0; t < osize; t++) {
      cout << beta[i][t] << '\t';
    }
    cout << endl;
  }
}

void HMM::display(ofstream &fcout) { 
  char c;
  if (tp == AA)
    c = 'A';
  else
    c = 'R';
  fcout << " -- P\t------------------------------- A\t" << c << endl;
  for (int j = 0; j < HMM_size; j++) {
    fcout << int (1000 * Pm[testNum][iit][tp][fl][j]) / 1000.0 << '\t';
    for (int i = 0; i < HMM_size; i++) {
      fcout << int(Am[testNum][iit][tp][fl][j][i] * 1000) / 1000.0 << '\t';
    }
    fcout << endl;
  }
  
  fcout << " \t------------------------------- B\t" << c << endl;
  for (int v = 0; v < noVals; v++) {
    fcout << '\t';
    for (int i = 0; i < HMM_size; i++) {
      fcout << int(Bm[testNum][iit][tp][fl][i][v] * 1000) / 1000.0 << '\t';
    }
    fcout << endl;
  }
}
