#include "grn.h"

void ORF::display(int f, ofstream &fout) {
  fout << name << "(" << max[f] << ", " << min[f] 
       << ")" << ": \t";
  for (int e = 0; e < noe[f]; e++) {
    fout << int(eLevel[f][e]*100.0) / 100.0 << '\t'; 
  }
  fout << endl << "\t\t\t";
  for (int e = 0; e < noe[f]; e++) {
    fout << catLev[f][e] << '\t'; 
  }
  fout << endl << "\t\t\t";
  for (int e = 0; e < noe[f]; e++) {
    fout << valid[f][e] << '\t'; 
  }
  fout << endl;
}

ORF::ORF(){
  for (int f = 0; f < NOF; f++) {
    noe[f] = 0;
    max[f] =-10;
    min[f] = 10;
    for (int e = 0; e < NOE; e++) {
      valid [f][e] = FALSE;
    }
  }
}

Rr::Rr() {
  for(int e =0; e < MAXEPSZ; e++) {
    eCount[e] = 0; // vCount[e] = 0;
    for (int f = 0; f < NOF; f++)
      eCountF[e][f] = 0; // vCountF[e][f] = 0;
  }
  for (int f = 0; f < NOF; f++) {
    noep[f] = noepN[f] = 0; // norv[f] = norvN[f] = 0; // 
  }

  for (int st = 0; st < 4; st++) {
    scoreAvr[st] = 0.0;
  }

  Score1 = 0;
  for (int fl = 0; fl < NOF; fl++) {
    Score2f[fl] = 0;
    for (int iit = 0; iit < TOTAL_ITERATIONS; iit++) {
      Score3[fl][iit] = 0;
    }
  }
  for (int iit = 0; iit < TOTAL_ITERATIONS; iit++) {
    Score2i[iit] = 0;
  }
}

