#include "grn.h"

Tuple::Tuple(ExpressionData *e){
  ed = e;
  rp = tp = 0;
  for (int i = 0; i < 100; i++)
    mp[i] = 0;
  mp[39] = 0;
  mp[40] = 1;
  mp[41] = 2;
  mp[49] = 3;
  mp[50] = 4;
  mp[51] = 5;
  mp[59] = 6;
  mp[60] = 7;
  mp[61] = 8;
  pm[0] = -11;
  pm[1] = -10;
  pm[2] = -9;
  pm[3] = -1;
  pm[4] = 0;
  pm[5] = 1;
  pm[6] = 9;
  pm[7] = 10;
  pm[8] = 11;
  for (int f = 0; f < NOF; f++) {
    noe[f] = ed->noe[f]; //numberOfExpressions[f];
  }
}

void Tuple::createRR() {
  string TYpe[] = {"Number of Activation Relations .......:\t", 
		   "Number of Repression Relations .......:\t", "xx", 
		   "Number of Randomly Generated Relations:\t"};
  cerr << endl;
  for (ti = AA; ti < 4; ti++) {
    if (ti != 2) {
      cerr << TYpe[ti] << ed->rrSZ[ti] << endl;
    }
    for (rg = 0; rg < ed->rrSZ[ti]; rg++) {
      join(ed->orf[ed->rr[ti][rg].reg], ed->orf[ed->rr[ti][rg].tar]);
      scanTD(ed->rr[ti][rg].type);
      reSymble(ed->rr[ti][rg]);
    }
  }
}

void Tuple::reSymble(Rr &rr) {

  for (int f = 0; f < NOF; f++) {
    for (int e = 0; e < noe[f]; e++) {
      if (rr.vld[f][e] == TRUE)
	rr.seq[f][e] = mp[rr.seq[f][e] + 50];
      // else
      //   rr.nomis[f]++;;
    }
    for (int p = 0; p < rr.noep[f]; p++) {
      for (int e = 0; e < rr.epSize[f][p]; e++) {
	rr.ep[f][p][e] = mp[rr.ep[f][p][e] + 50];
      }
    }
  }
}

Tuple::~Tuple() {
}

void Tuple::join (ORF &r, ORF &t) {
  for (int f = 0; f < NOF; f++) {
    for (int e = 0; e < NOE; e++) {
      validL[f][e] = FALSE;
      sumL  [f][e] = 5;
      mulL  [f][e] = 0;
    }
  }
  for (int f = 0; f < NOF; f++) {
    for (int e = 0; e < noe[f]; e++) {  // -------------------- ( - 1)
      if ((r.valid[f][e] == TRUE) && (t.valid[f][e] == TRUE)) {
	sumL  [f][e] = r.catLev[f][e] * 10 + t.catLev[f][e];
	validL[f][e] = TRUE;
	mulL  [f][e] = r.catLev[f][e] * t.catLev[f][e];
	if (mulL[f][e] > 0) mulL[f][e] =  1;
	if (mulL[f][e] < 0) mulL[f][e] = -1;
      } else {
	validL[f][e] = FALSE;
      }
    } // e
  }// f
}

void Tuple::scanTD(char type) {
  int lenA;
  int lenR;
  int pointSA;
  int pointSR;
  int pointEA;
  int pointER;
  for (int f = 0; f < NOF; f++) {
    lenA = lenR = 0; 
    pointSA = pointSR = 0;
    pointEA = pointER = 0;
    for (int e = 0; e < noe[f]; e++) {
      ed->rr[ti][rg].seq[f][e] = sumL[f][e];
      ed->rr[ti][rg].vld[f][e] = validL[f][e];
    }
    for (int e = 0; e < noe[f]; e++) {
      if (validL[f][e] == TRUE) { // A tpl
	if (lenA == 0)
	  pointSA = e;
	pointEA = e;
	lenA = pointEA - pointSA + 1;
      } else { 
	if (lenA >= SLEN) { // save seq
	  // -=-=-================================================ 
	  ed->rr[ti][rg].epStart[f][ed->rr[ti][rg].noep[f]] = pointSA;
	  ed->rr[ti][rg].epEnd[f][ed->rr[ti][rg].noep[f]]   = pointEA;
	  ed->rr[ti][rg].epSize[f][ed->rr[ti][rg].noep[f]]  = lenA;
	  for (int se = pointSA; se <= pointEA; se++) {
	    ed->rr[ti][rg].ep[f][ed->rr[ti][rg].noep[f]][se - pointSA] = sumL[f][se];
	  }
	  (ed->rr[ti][rg].eCount[lenA])++;
	  (ed->rr[ti][rg].eCountF[lenA][f])++;
	  (ed->rr[ti][rg].noep[f])++;
	  // -=-=-================================================
	} // ------------ End save seq 
	lenA = 0;
      } 
    } 
    if (lenA >= SLEN) { // save seq
      // -=-=-================================================ 
      ed->rr[ti][rg].epStart[f][ed->rr[ti][rg].noep[f]] = pointSA;
      ed->rr[ti][rg].epEnd[f][ed->rr[ti][rg].noep[f]]   = pointEA;
      ed->rr[ti][rg].epSize[f][ed->rr[ti][rg].noep[f]]  = lenA;
      for (int se = pointSA; se <= pointEA; se++) {
	ed->rr[ti][rg].ep[f][ed->rr[ti][rg].noep[f]][se - pointSA] = sumL[f][se];
      }
      (ed->rr[ti][rg].eCount[lenA])++;
      (ed->rr[ti][rg].eCountF[lenA][f])++;
      (ed->rr[ti][rg].noep[f])++;
      // -=-=-================================================
    } // ------------ End save seq 
  } // f
}

